DECLARE SUB Einladen (na$, nu1, nu2, tm1#(), tm2#(), simultm1#(), simultm2#())
DECLARE SUB Resampling (nu1, nu2, oldtm1#(), oldtm2#(), newtm1#(), newtm2#())
DECLARE SUB Difference (jres, nu1, nu2, simultm1#(), simultm2#(), store#())
COMMON SHARED orig#
REM **** Name: FTBOOT.BAS, Vers. 30.9.2006 for Freebasic *****
REM ********************************
REM *******************************************
CLS : PRINT
PRINT "  Two-sample comparison (t-test) by bootstrapping within the samples. "
PRINT
PRINT "(Copyright Hans L. Nemeschkal, Vienna 2006 - "
PRINT " Department of Theoretical Biology, University of Vienna,"
PRINT " Althanstrasse 14, A-1090 Vienna, Austria)"
PRINT
PRINT "Input please -"
INPUT "number of resamplings:"; res: PRINT
PRINT "(Note please that the input-data file has to be an ASCII-file,"
PRINT "       the cases in rows, i.e. n1 cases of sample-1 followed by"
PRINT "       n2 cases of sample-2 !)"
PRINT
PRINT "Input please -"
INPUT "name of input-data file:"; ns$: PRINT
INPUT "number of cases in sample-1 (= n1):"; nu1
INPUT "number of cases in sample-2 (= n2):"; nu2
oz = nu1 + nu2
PRINT "The number of cases (=rows) in the input-data file is "; oz
REM number of character variates, vz
vz = 1
PRINT
PRINT "Input please -"
INPUT "full path of input-data file:"; pfad$: PRINT
PRINT "Note please -"
PRINT "The results of calculations are parallely saved in an "
PRINT "ASCII-file (=results-file) !"
PRINT "Input please -"
INPUT "name of results-file:"; nsergebnis$: PRINT
INPUT "full path of results-file:"; erpfad$: PRINT
REM ======= starting the procedure-clock ===============
orig# = TIMER
RANDOMIZE orig#
na$ = pfad$ + ns$
naergebnis$ = erpfad$ + nsergebnis$
para = 4
DIM tm1#(nu1), tm2#(nu2), simultm1#(nu1), simultm2#(nu2)
DIM store#(res, para)

REM  ****** reading input-data file
CALL Einladen(na$, nu1, nu2, tm1#(), tm2#(), simultm1#(), simultm2#())
REM ************************

jres = 0
CALL Difference((jres), nu1, nu2, simultm1#(), simultm2#(), store#())
REM ************************
REM resampling-routine
REM ************************
sutestv1# = 0
rem testv1# = store#(0, 3): REM for testing zero-significance of difference
testv1# = 0
sutestv2# = 0
rem testv2# = store#(0, 4): REM for testing zero-significance of difference
testv2# = 0

FOR jres = 1 TO res
  CALL Resampling((nu1), (nu2), tm1#(), tm2#(), simultm1#(), simultm2#())
  CALL Difference((jres), nu1, nu2, simultm1#(), simultm2#(), store#())

  REM **** P-value
  IF store#(jres, 3) > testv1# THEN sutestv1# = sutestv1# + 1
  IF store#(jres, 4) > testv2# THEN sutestv2# = sutestv2# + 1
NEXT jres

REM ***** theoretical possible critical value for P-value in the case
REM ***** of systematic bootstrap
max1# = LOG(nu1) * nu1
max2# = LOG(nu2) * nu2
max# = (max1# + max2#)
pmax# = EXP(-max#)


REM **** P-value -  *********
REM *** two-sided test *****
proa1# = sutestv1# / res: prob1# = 1 - proa1#
IF proa1# >= prob1# THEN pvalue1# = 2 * prob1#
IF prob1# > proa1# THEN pvalue1# = 2 * proa1#
REM pvalue1# .... Pvalue of the between sample-difference (raw difference of means)

proa2# = sutestv2# / res: prob2# = 1 - proa2#
IF proa2# >= prob2# THEN pvalue2# = 2 * prob2#
IF prob2# > proa2# THEN pvalue2# = 2 * proa2#
REM pvalue2# .... Pvalue of the between sample-tvalue



REM ********** output as ASCII-results-file *********************
OPEN naergebnis$ FOR APPEND AS #1
REM OPEN naergebnis$ FOR OUTPUT AS #1
PRINT #1, " "
PRINT #1, "____________________________________________________________"
PRINT #1, "date of calculations: "; DATE$; "    time of calculations: "; TIME$: PRINT #1, " "
PRINT #1, "      Bootstrap - "
PRINT #1, "   Comparison of two samples"
PRINT #1, " "
PRINT #1, "number of resamplings: "; res
PRINT #1, "name of input-data file: "; ns$
PRINT #1, "number of cases in sample-1 (= n1): "; nu1
PRINT #1, "number of cases in sample-2 (= n2): "; nu2
PRINT #1, "*******************************************************"
REM *************** values of the observed samples *******
PRINT #1, " "
PRINT #1, "values of the observed samples:"
PRINT #1, ""
PRINT #1, "sample-1"
PRINT #1, "   average-1:"; store#(0, 1)
PRINT #1, ""
PRINT #1, "sample-2"
PRINT #1, "   average-2:"; store#(0, 2)
PRINT #1, ""
PRINT #1, "difference between (average-1 - average-2):  "; store#(0, 3)
axx! = pvalue1# / 2
PRINT #1, ""
PRINT #1, "P-value of the difference between samples (one-sided):  "; axx!
axx! = pvalue1#
PRINT #1, ""
PRINT #1, "P-value of the difference between samples (two-sided):  "; axx!
PRINT #1, ""
PRINT #1, "tvalue:  "; store#(0, 4)
ayy! = pvalue2# / 2
PRINT #1, ""
PRINT #1, "P-value of the tvalue (one-sided):  "; ayy!
PRINT #1, ""
ayy! = pvalue2#
PRINT #1, ""
PRINT #1, "P-value of the tvalue (two-sided):  "; ayy!
PRINT #1, ""

PRINT #1, "(Note please that in the case of systematic bootstrapping"
PRINT #1, " the theoretically P-value can be minimally"
PRINT #1, " as small as (one-sided test) "; pmax#; " and"
PRINT #1, " as small as (two-sided test) "; 2 * pmax#; "   )"
REM ************
CLOSE #1
REM ====== to read the clock================
stopuhr# = TIMER - anfang#
PRINT "duration of calculations in seconds:"; stopuhr#

END

SUB Difference (jres, nu1, nu2, simultm1#(), simultm2#(), store#())
su# = 0
FOR zl = 1 TO nu1
    su# = su# + simultm1#(zl)
NEXT zl
REM average-1
av1# = su# / nu1
suqua# = 0
FOR zl = 1 TO nu1
    suqua# = suqua# + (simultm1#(zl) - av1#) * (simultm1#(zl) - av1#)
NEXT zl
var1# = suqua# / (nu1 - 1)


su# = 0
FOR zl = 1 TO nu2
    su# = su# + simultm2#(zl)
NEXT zl
REM average-2
av2# = su# / nu2
suqua# = 0
FOR zl = 1 TO nu2
    suqua# = suqua# + (simultm2#(zl) - av2#) * (simultm2#(zl) - av2#)
NEXT zl
var2# = suqua# / (nu2 - 1)
diff# = av1# - av2#
denom# = (var1# / nu1) + (var2# / nu2)
IF denom# <> 0 THEN denom# = SQR(denom#): tval# = diff# / denom#
IF denom# = 0 THEN tval# = 0



REM *************** values of the original samples  *******
REM ******** in store (0,para) ******
Ausgang:

store#(jres, 1) = av1#: REM ** average-1
store#(jres, 2) = av2#: REM ** average-2
store#(jres, 3) = diff#: REM ** difference=(average-1 - average-2)
store#(jres, 4) = tval#: REM ** tvalue
END SUB

SUB Einladen (na$, nu1, nu2, tm1#(), tm2#(), simultm1#(), simultm2#())
OPEN na$ FOR INPUT AS #3
REM sample-1
FOR zl = 1 TO nu1
         INPUT #3, tm1#(zl): simultm1#(zl) = tm1#(zl)
         PRINT tm1#(zl)
NEXT zl
REM sample-2
FOR zl = 1 TO nu2
         INPUT #3, tm2#(zl): simultm2#(zl) = tm2#(zl)
         PRINT tm2#(zl)
NEXT zl

CLOSE #3
END SUB

STATIC SUB Resampling (nu1, nu2, oldtm1#(), oldtm2#(), newtm1#(), newtm2#())
az = 1: ez = nu1
FOR j = 1 TO nu1
 REM ****** random number *********
   ax = INT((ez - az + 1) * RND(1) + az)
   rem print ax
     REM ***** new case
     newtm1#(j) = oldtm1#(ax)
NEXT j


az = 1: ez = nu2
FOR j = 1 TO nu2
 REM ****** random number *********
 REM *** ax ... resulting random number
   ax = INT((ez - az + 1) * RND(1) + az)
   rem print ":"; ax
     REM ***** new case
     newtm2#(j) = oldtm2#(ax)

NEXT j

END SUB

